// Virtual Universe Vaccum robot sample 


#include <winsock.h>
#include "stdio.h"
#include "conio.h"

SOCKET s; //Socket handle

//CONNECTTOHOST ? Connects to a remote host
bool ConnectToHost(int PortNo, char* IPAddress)
{
    //Start up Winsock?
    WSADATA wsadata;

    int error = WSAStartup(0x0202, &wsadata);

    //Did something happen?
    if (error)
        return false;

    //Did we get the right Winsock version?
    if (wsadata.wVersion != 0x0202)
    {
        WSACleanup(); //Clean up Winsock
        return false;
    }

    //Fill out the information needed to initialize a socket?
    SOCKADDR_IN target; //Socket address information

    target.sin_family = AF_INET; // address family Internet
    target.sin_port = htons (PortNo); //Port to connect on
    target.sin_addr.s_addr = inet_addr (IPAddress); //Target IP

    s = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP); //Create socket
    if (s == INVALID_SOCKET)
    {
        return false; //Couldn't create the socket
    }  

    //Try connecting...

    if (connect(s, (SOCKADDR *)&target, sizeof(target)) == SOCKET_ERROR)
    {
        return false; //Couldn't connect
    }
    else
        return true; //Success
}

//CLOSECONNECTION ? shuts down the socket and closes any connection on it
void CloseConnection ()
{
    //Close the socket if it exists
    if (s)
        closesocket(s);

    WSACleanup(); //Clean up Winsock
}


char buf[128];

void _send(char *str)
{
send(s,str,strlen(str),0);
memset(buf,0,128);
recv(s,buf,128,0);
}


double _getvalue(char *str)
{
char *p;
_send(str);
p=strstr(buf,"ROK:");
if(p) return atof(&p[4]);
return 0;
}



void main(void)
{
if(ConnectToHost(6000,"127.0.0.1"))
	{
	int stop=0;
	memset(buf,0,128);
	recv(s,buf,128,0);
	printf("Connected: %s",buf);

	do
		{
		printf("\r\nGo straight (press ESC to stop program)...");
		_send("moteurdroitavant=1;moteurgaucheavant=1");

		while(_getvalue("detecteurcollision")==0 &&	_getvalue("detecteurcide")==0)
			{
			if(kbhit()&&getch()==27)
				{
				stop=1;
				break;
				}
			}

		if(stop) break;
		printf("\r\nGo back...");
		_send("moteurdroitavant=0;moteurgaucheavant=0;moteurdroitarriere=1;moteurgauchearriere=1");
		Sleep(4000);
	
		printf("\r\nRotating...");	
		_send("moteurdroitavant=1;moteurdroitarriere=0");
		Sleep(2000);
		
		
		_send("moteurgauchearriere=0");

		}
	while(1);

	CloseConnection();
	}
}
